package editor

import (
	"io"

	"b612.me/apps/b612/bed/event"
	"b612.me/apps/b612/bed/layout"
	"b612.me/apps/b612/bed/state"
)

// Manager defines the required window manager interface for the editor.
type Manager interface {
	Init(chan<- event.Event, chan<- struct{})
	Open(string) error
	Read(io.Reader) error
	SetSize(int, int)
	Resize(int, int)
	Emit(event.Event)
	State() (map[int]*state.WindowState, layout.Layout, int, error)
	Close()
}
